'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _store = require('./flux/store');

var _router = require('./routing/router');

var _mount = require('./tags/mount');

var _riot = require('riot');

var Riot = _interopRequireWildcard(_riot);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var App = function () {
    _createClass(App, [{
        key: 'setRouter',
        value: function setRouter(routes) {
            var initialAdrress = arguments.length <= 1 || arguments[1] === undefined ? '/' : arguments[1];
            var options = arguments[2];

            if (options != undefined) this.router.configure(options);
            this.router = new _router.Router(routes);
            this.router.init(initialAdrress);
            var riotRedux = function riotRedux(router) {

                function init() {
                    this.router = router;
                }

                return { init: init };
            };
            Riot.mixin(riotRedux(this.router));
        }
    }, {
        key: 'init',
        value: function init(selector, container) {
            this.container = (0, _mount.mountToDom)(selector, container);
        }
    }]);

    function App(reducer) {
        _classCallCheck(this, App);

        this.store = new _store.Store(reducer);
        var riotRedux = function riotRedux(store) {

            function init() {
                this.store = store;
            }

            return { init: init };
        };

        Riot.mixin(riotRedux(this.store));
    }

    _createClass(App, [{
        key: 'redirect',
        value: function redirect(address) {
            this.router.redirect(address);
        }
    }, {
        key: 'dispatch',
        value: function dispatch(action) {
            this.store.dispatch(action);
        }
    }, {
        key: 'getState',
        value: function getState() {
            return this.store.getState();
        }
    }, {
        key: 'subscribe',
        value: function subscribe(listener) {
            return this.store.subscribe(listener);
        }
    }]);

    return App;
}();

exports.default = App;