'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AsyncAction = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _action = require('./action');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AsyncAction = exports.AsyncAction = function () {
    function AsyncAction(type, asyncFunction, payloadReducer) {
        _classCallCheck(this, AsyncAction);

        this.type = type;
        this.asyncFunction = asyncFunction;
        this.payloadReducer = payloadReducer;
        this.request = new _action.Action(type + '.REQUEST', payloadReducer);
        this.response = new _action.Action(type + '.RESPONSE');
        this.error = new _action.Action(type + '.ERROR');
    }

    _createClass(AsyncAction, [{
        key: 'reduce',
        value: function reduce() {
            if (this.payloadReducer) {
                return this.payloadReducer.apply(this, arguments);
            } else {
                return arguments.length <= 0 ? undefined : arguments[0];
            }
        }
    }, {
        key: 'payload',
        value: function payload() {
            var _this = this;

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return function (dispatch) {
                var _request;

                dispatch((_request = _this.request).payload.apply(_request, args));

                _this.asyncFunction(_this.reduce.apply(_this, args), function (err, res) {
                    if (err !== null) {
                        dispatch(_this.error.payload(err));
                    } else {
                        dispatch(_this.response.payload(res));
                    }
                });
            };
        }
    }]);

    return AsyncAction;
}();