'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var objectAssign = require('object-assign');

var Reducer = exports.Reducer = function Reducer(handlers, defaultState) {
    _classCallCheck(this, Reducer);

    this.handlers = handlers;
    this.defaultState = defaultState;
    return function (state, action) {
        if (state === undefined) state = defaultState;
        var handler = handlers.filter(function (handler) {
            return handler.action.type === action.type;
        });
        if (handler.length >= 1) {
            return objectAssign({}, state, handler[0].reduce(state, action.payload));
        }
        return objectAssign({}, state);
    };
};