'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RequestAction = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _action = require('./action');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var request = require('superagent');

var RequestAction = function () {
    function RequestAction(type, url, requestType, options) {
        _classCallCheck(this, RequestAction);

        this.type = type;
        this.url = url;
        this.requestType = requestType;
        this.options = options || {};
        this.request = new _action.Action(type + '.REQUEST');
        this.response = new _action.Action(type + '.RESPONSE');
        this.error = new _action.Action(type + '.ERROR');
    }

    _createClass(RequestAction, [{
        key: 'payload',
        value: function payload(_payload) {
            var _this = this;

            if (_payload === undefined) _payload = { data: {}, query: {} };
            if (_payload.data === undefined) _payload.data = {};
            if (_payload.query === undefined) _payload.query = {};

            if (this.url === undefined) throw new Error('Parameter url is missing in RequestAction: ' + this.type + '.');
            if (this.requestType === undefined) throw new Error('Parameter requestType is missing in RequestAction: ' + this.type + '.');

            return function (dispatch) {
                dispatch(_this.request.payload(_payload));

                var data = {};

                if (_payload.template === undefined) {
                    data.template = {};
                } else {
                    data.template = _payload.template;
                    _payload.template = undefined;
                }

                if (_payload.url === undefined) {
                    data.url = _this.url;
                } else {
                    data.url = _payload.url;
                    _payload.url = undefined;
                }

                if (_payload.requestType === undefined) {
                    data.requestType = _this.requestType;
                } else {
                    data.requestType = _payload.requestType;
                    _payload.requestType = undefined;
                }

                if (_payload.options === undefined) {
                    data.options = _this.options;
                } else {
                    data.options = _payload.options;
                    _payload.options = undefined;
                }

                if (_this.url === undefined) throw new Error('Parameter url is missing in RequestAction: ' + _this.type + '.');
                if (_this.requestType === undefined) throw new Error('Parameter requestType is missing in RequestAction: ' + _this.type + '.');

                var regex = /{(.*)}/g;
                var match = [];

                while (match = regex.exec(data.url)) {

                    var key = match[0];
                    var value = match[1];

                    if (data.template[value] !== undefined) {
                        data.url = data.url.replace(key, data.template[value]);
                    }
                }

                request(data.requestType, data.url).send(_payload.data).query(_payload.query).set(data.options).end(function (err, res) {
                    if (err !== null) {
                        dispatch(_this.error.payload(err));
                    } else {
                        dispatch(_this.response.payload(res.body));
                    }
                });
            };
        }
    }]);

    return RequestAction;
}();

exports.RequestAction = RequestAction;