'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Store = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _redux = require('redux');

var Redux = _interopRequireWildcard(_redux);

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _reduxLogger = require('redux-logger');

var _reduxLogger2 = _interopRequireDefault(_reduxLogger);

var _reduxCatch = require('redux-catch');

var _reduxCatch2 = _interopRequireDefault(_reduxCatch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var objectAssign = require('object-assign');

var Store = exports.Store = function () {
    function Store(reducer) {
        _classCallCheck(this, Store);

        var rootReducer;

        if ((typeof reducer === 'undefined' ? 'undefined' : _typeof(reducer)) === 'object') {
            rootReducer = Redux.combineReducers(reducer);
        } else {
            rootReducer = reducer;
        }

        function errorHandler(error, getState) {
            console.error(error);
            console.debug('current state', getState());
        }

        var middleware = [(0, _reduxCatch2.default)(errorHandler), _reduxThunk2.default, (0, _reduxLogger2.default)()];

        var createStoreWithMiddleware = Redux.compose(Redux.applyMiddleware.apply(Redux, middleware))(Redux.createStore);

        this._store = createStoreWithMiddleware(rootReducer);
    }

    _createClass(Store, [{
        key: 'dispatch',
        value: function dispatch(action) {
            var getType = {};
            if (action.payload && getType.toString.call(action.payload) === '[object Function]') {
                action = action.payload();
            }
            return this._store.dispatch(action);
        }
    }, {
        key: 'getState',
        value: function getState() {
            return objectAssign({}, this._store.getState());
        }
    }, {
        key: 'subscribe',
        value: function subscribe(listener) {
            return this._store.subscribe(listener);
        }
    }]);

    return Store;
}();