'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Corky = undefined;

var _app = require('./app');

var _app2 = _interopRequireDefault(_app);

var _element = require('./tags/element');

var _mount = require('./tags/mount');

var _template = require('./tags/template');

var _Router = require('./routing/Router');

var _Route = require('./routing/Route');

var _action = require('./flux/action');

var _asyncAction = require('./flux/asyncAction');

var _batchAction = require('./flux/batchAction');

var _reducer = require('./flux/reducer');

var _requestAction = require('./flux/requestAction');

var _service = require('./flux/service');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Corky = exports.Corky = {
    App: _app2.default,
    Tags: {
        Element: _element.Element,
        mountMany: _mount.mountMany,
        mountToManyDom: _mount.mountToManyDom,
        mount: _mount.mount,
        mountToDom: _mount.mountToDom,
        registerElement: _template.registerElement,
        registerService: _template.registerService
    },
    Routing: {
        Route: _Route.Route,
        Router: _Router.Router
    },
    Flux: {
        Action: _action.Action,
        AsyncAction: _asyncAction.AsyncAction,
        BatchAction: _batchAction.BatchAction,
        Reducer: _reducer.Reducer,
        RequestAction: _requestAction.RequestAction,
        Service: _service.Service
    }

};

exports.default = Corky;