'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Router = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _route = require('./route');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var director = require('director');

var Router = exports.Router = function () {
    function Router(routes) {
        _classCallCheck(this, Router);

        this.routes = routes;
        if (routes != undefined) {
            this._router = new director.Router(this.transform(routes));
        }
    }

    _createClass(Router, [{
        key: 'transform',
        value: function transform(routes) {
            var result = {};
            for (var route in routes) {
                if (routes[route].address !== undefined && routes[route].on !== undefined) {
                    result[routes[route].address] = {};
                    result[routes[route].address].on = routes[route].on;
                    if (routes[route].after !== undefined) result[routes[route].address].after = routes[route].after;
                    if (routes[route].before !== undefined) result[routes[route].address].before = routes[route].before;
                    if (routes[route].once !== undefined) result[routes[route].address].once = routes[route].once;

                    if (routes[route].transform === undefined) {
                        routes[route] = new _route.Route(routes[route]);
                    }

                    routes[route].transform(result[routes[route].address]);
                }
            }
            return result;
        }
    }, {
        key: 'init',
        value: function init(initAddress) {
            this._router.init(initAddress);
        }
    }, {
        key: 'redirect',
        value: function redirect(address) {
            this._router.setRoute(address);
        }
    }, {
        key: 'configure',
        value: function configure(options) {
            this._router.configure(options);
        }
    }]);

    return Router;
}();